(* a simple NCurses UI Library *)

type point = int * int (* x and y *)

type buffer = string list

exception ScreenNotOpen
exception NoRootWidget


type 'a member = {
    set : 'a -> unit;
    get : unit -> 'a
}

type widget = {
    minSize: point member;
    paint: point -> buffer;
}

val member_init : 'a -> 'a member
val label: string -> widget

val update : unit -> unit
val set_root_widget : widget -> unit
val screen_open  : unit -> unit
val screen_close : unit -> unit



